// Unreal Fighting Framework by Kevin Poretti

#pragma once

// UE includes
#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "Containers/RingBuffer.h"

#include "FFInputBufferComponent.generated.h"

struct FFFInputState;

USTRUCT()
struct FFFInputSequence
{
    GENERATED_BODY()
    
};

UCLASS( ClassGroup=(Custom), meta=(BlueprintSpawnableComponent) )
class UNREALFIGHTINGFRAMEWORK_API UFFInputBufferComponent : public UActorComponent
{
	GENERATED_BODY()

public:	
	UFFInputBufferComponent();

	void Initialize(int32 BufferSize = 120);

	void AddInput(const FFFInputState& InputState);

	bool CheckInputSequence(const FFFInputSequence& InputSequence);

protected:
	/** The underlying buffer data structure for holding past input states */
	TRingBuffer<FFFInputState> Buffer;
};
